﻿Imports System.Runtime.InteropServices
Imports MaxIm

<ComClass(PlugIn.ClassId, PlugIn.InterfaceId, PlugIn.EventsId)>
Public Class PlugIn

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "850622DF-B0DA-4CCB-B23D-54C0A1C4A8D8"
    Public Const InterfaceId As String = "5D9ADC85-FEED-4131-8BB6-7F1F2BD476AD"
    Public Const EventsId As String = "2FC011B2-352E-4828-9106-0C8C55FD1C89"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub DoModal(ByVal Doc As MaxIm.Document)

        Dim myApp As New MaxIm.Application

        Dim myDocs As MaxIm.Documents
        myDocs = myApp.Documents
        Dim ImgColl As New Collection
        Dim i As Integer


        For i = 1 To myDocs.Count()
            ImgColl.Add(myDocs.Item(i))
        Next

        Dim targetDoc As New MaxIm.Document
        targetDoc.CombineImages(AlignType.mxNoAlignment, False, CombineType.mxMedianCombine, False, ImgColl)

        targetDoc.Modified = True

        Marshal.ReleaseComObject(targetDoc)
        Marshal.ReleaseComObject(myDocs)
        Marshal.ReleaseComObject(myApp)
    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return "MaxIm DL Sample VB.Net Plugin - CombineDocs"
        End Get
    End Property

End Class


