﻿Imports System.Runtime.InteropServices
Imports MaxIm

<ComClass(PlugIn.ClassId, PlugIn.InterfaceId, PlugIn.EventsId)>
Public Class PlugIn

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "61DC346E-C5B5-4247-A2E5-31DD7653467C"
    Public Const InterfaceId As String = "32BEE4D1-8C73-456D-8512-B7224AC1AF20"
    Public Const EventsId As String = "7D01DD46-F724-45F9-89A7-A91AE3C07779"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub DoModal(ByVal Doc As MaxIm.Document)

        Dim myStr As String
        myStr = ""

        Dim myApp As MaxIm.Application
        myApp = New MaxIm.Application()
        Dim myDocs As MaxIm.Documents
        myDocs = myApp.Documents

        Dim docsCount As Integer
        docsCount = myDocs.Count()
        myStr = docsCount.ToString() + " documents" + vbCrLf

        Dim doc2 As MaxIm.Document
        doc2 = Nothing

        For i = 1 To docsCount

            doc2 = myDocs.Item(i)
            myStr = myStr + doc2.DisplayName + vbCrLf
        Next i


        MsgBox(myStr)

        Marshal.ReleaseComObject(doc2)
        Marshal.ReleaseComObject(myDocs)
        Marshal.ReleaseComObject(myApp)

    End Sub

Public ReadOnly Property Name() As String
    Get
            Return "MaxIm DL Sample VB.Net Plugin - ListDocs1"
        End Get
End Property

End Class




